/*Created 4/23/03*/
//Code for functions ran1 and NormalRandom
//See header file.
#include<iostream.h>
#include<math.h>
#include "normaldeviates.h"


//Returns a random number between 0 and 1.
//Initialize with a negative number.
float ran1(long *ANegNum)
{
	int j;
	long k;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if (*ANegNum <= 0 || !iy) {
		if (-(*ANegNum) < 1) *ANegNum=1;
		else *ANegNum = -(*ANegNum);
		for (j=NTAB+7;j>=0;j--) {
			k=(*ANegNum)/IQ;
			*ANegNum=IA*(*ANegNum-k*IQ)-IR*k;
			if(*ANegNum < 0) *ANegNum +=IM;
			if(j < NTAB) iv[j] = *ANegNum;
		}
		iy=iv[0];
	}
	k=(*ANegNum)/IQ;
	*ANegNum=IA*(*ANegNum-k*IQ)-IR*k;
	if(*ANegNum<0) *ANegNum += IM;
	j=iy/NDIV;
	iy=iv[j];
	iv[j]=*ANegNum;
	if ((temp=(const float)AM*iy)>RNMX) return (float)RNMX;
	else return temp;
}


//Returns a number drawn randomly from the Standard Normal (mean=0, sd =1).
float StdNorm(long *ANegNum)
{
	float ran1(long *ANegNum);
	static int iset=0;
	static float gset;
	float fac,rsq,v1,v2;
	
	if(*ANegNum<0) iset=0;
	if (iset == 0) {
		do {
			v1=(float)(2.0*ran1(ANegNum)-1.0);
			v2=(float)(2.0*ran1(ANegNum)-1.0);
			rsq=v1*v1+v2*v2;
		} while (rsq >= 1.0 || rsq == 0.0);
		fac=(float)sqrt(-2.0*log(rsq)/rsq);

		gset=v1*fac;
		iset=1;
		return v2*fac;
	} else {
		iset=0;
		return gset;
	}
}

